



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>ARGB32 to YUV12 利用 SDL1.2 SDL_ttf 在视频表面输出文本</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">ARGB32 to YUV12 利用 SDL1.2 SDL_ttf 在视频表面输出文本</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-21 01:07:30 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>提示:ARGB alpha通道的A + 原YUV表面的y0 + 要写进去的y1 = 计算出新的y2.<br /><br />
计算公式为<b> ( y1 * a + y0 * ( 255 - a ) ) / 255 </b></p>
<pre class="prettyprint linenums">
void  rgb2yuv(int r, int g, int b, int *y, int *u, int *v)<br />
{<br />
	int y0, u0, v0;

	y0 =  66*r + 129*g +  25*b;<br />
	u0 = -38*r + -74*g + 112*b;<br />
	v0 = 112*r + -94*g + -18*b;

	y0 = (y0+128)&gt;&gt;8;<br />
	u0 = (u0+128)&gt;&gt;8;<br />
	v0 = (v0+128)&gt;&gt;8;

	*y = y0 + 16;<br />
	*u = u0 + 128;<br />
	*v = v0 + 128;<br />
}

void  yuv2rgb(int y, int u, int v, int *r, int *g, int *b)<br />
{<br />
	int r0,g0,b0;<br />
	v = v - 128;<br />
	u = u - 128;<br />
	r0 = y + v + (v&gt;&gt;2) + (v&gt;&gt;3) + (v&gt;&gt;5);<br />
	g0 = y - ((u&gt;&gt;2) + (u&gt;&gt;4) + (u&gt;&gt;5)) - ((v&gt;&gt;1) + (v&gt;&gt;3) + (v&gt;&gt;4) + (v&gt;&gt;5));<br />
	b0 = y + u + (u&gt;&gt;1) + (u&gt;&gt;2) + (u&gt;&gt;6);

	*r = r0 &gt; 255 ? 255: r0;<br />
	*g = g0 &gt; 255 ? 255: g0;<br />
	*b = b0 &gt; 255 ? 255: b0;<br />
}

int blitSurface2YUV(SDL_Surface *src, SDL_Overlay *dst, SDL_Rect *dstrect ,int isBlended)<br />
{<br />
	Uint8 r, g, b,a;<br />
	int y0,u0,v0;<br />
	int y1,u1,v1;<br />
	int y2,u2,v2;<br />
	int y,x;<br />
	int height = src-&gt;h h ? src-&gt;h: dstrect-&gt;h;<br />
	int width =  src-&gt;w w ? src-&gt;w: dstrect-&gt;w;<br />
	int uv_off = 0;<br />
	Uint32 pixel;

	printf ("src-&gt;format-&gt;BitsPerPixel %d src-&gt;format %08X\r\n",src-&gt;format-&gt;BitsPerPixel,src-&gt;format);

	if(dst-&gt;format != SDL_YV12_OVERLAY)return 1;

	for(y = 0; y format-&gt;BitsPerPixel)<br />
			{<br />
			case 8:<br />
				pixel = *((Uint8*)src-&gt;pixels + y*src-&gt;pitch + x);<br />
				break;<br />
			case 16:<br />
				pixel = *((Uint16*)src-&gt;pixels + y*src-&gt;pitch/2 + x);<br />
				break;<br />
			case 32:<br />
				pixel = *((Uint32*)src-&gt;pixels + y*src-&gt;pitch/4 + x);

				break;<br />
			default:<br />
				return -1;<br />
			}

			//SDL_GetRGB(pixel, src-&gt;format, &amp;r, &amp;g, &amp;b);<br />
			SDL_GetRGBA(pixel, src-&gt;format, &amp;r, &amp;g, &amp;b,&amp;a);

			rgb2yuv(r, g, b, &amp;y1, &amp;u1, &amp;v1);

			if(isBlended)<br />
			{<br />
				y0 = (dst-&gt;pixels[0][ (dstrect-&gt;y + y) * dst-&gt;pitches[0] + (dstrect-&gt;x + x)]);<br />
				v0 = (dst-&gt;pixels[1][ (uv_off + dstrect-&gt;y /2) * dst-&gt;pitches[1] + (dstrect-&gt;x/2 + x/2)]);<br />
				u0 = (dst-&gt;pixels[2][ (uv_off + dstrect-&gt;y /2) * dst-&gt;pitches[2] + (dstrect-&gt;x/2 + x/2)]);

				y2 = (Uint8)(( y1 * a + y0 * ( 255 - a ) ) / 255);<br />
				u2 = (Uint8)(( u1 * a + u0 * ( 255 - a ) ) / 255);<br />
				v2 = (Uint8)(( v1 * a + v0 * ( 255 - a ) ) / 255);

				y1=y2;<br />
				u1=u2;<br />
				v1=v2;<br />
			}

			memset(dst-&gt;pixels[0] + (dstrect-&gt;y + y) * dst-&gt;pitches[0] + (dstrect-&gt;x + x),<br />
				(Uint8)y1  , 1);

			if((x%2 == 0 ) &amp;&amp; (y%2 == 0 ))<br />
			{<br />
				memset(dst-&gt;pixels[1] + (uv_off + dstrect-&gt;y /2) * dst-&gt;pitches[1] + (dstrect-&gt;x/2 + x/2),<br />
					(Uint8)v1, 1);<br />
				memset(dst-&gt;pixels[2] + (uv_off + dstrect-&gt;y /2) * dst-&gt;pitches[2] + (dstrect-&gt;x/2 + x/2),<br />
					(Uint8)u1, 1);<br />
			}<br />
		}<br />
		if(y%2 == 0)++uv_off;<br />
	}<br />
	return 0;<br />
}
</pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/r8mlor9k.html">Android程序中--不能改变的事情</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxkw0j8.html">jvm--2&period;类加载机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k7oer9.html">javaweb学习总结&lpar;七&rpar;&mdash;&mdash;HttpServletResponse对象&lpar;一&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z111jx9.html">迪米特法则（LoD），即最少知识原则</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z147o19.html">Using the Repository Pattern with ASP&period;NET MVC and Entity Framework</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vlgkn8.html">知识点整理之Java的Cookie操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmo0z79.html">win8、win8&period;1官方版本、及安装密钥</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpp400q.html">Quartus II 11&period;0破发点（不同的是低版本号）</a>
		</li>
						<li><a href="https://www.batexi.com/a/93ypjz08.html">mac下virtualbox配置全网通</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jgdrx8.html">My Favorite Color</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kjpxe39.html">Centos7搭建SS以及加速配置的操作记录 &lpar;转载&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gm6nmq.html">&lbrack;Docker&rsqb;如何批量删除镜像</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj2d769.html">python second lesson</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5kz5eq.html">MySQL 存储修改</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4rk6k9.html">PHP几种加密方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1l0v5q.html">uniDBGrid实行多选表格行</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w1znnq.html">winform里直接使用WCF，不需要单独的WCF项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyyjvldq.html">efcore从数据库快速生成实体及context</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvr01j8.html">springboot自定义banner生成器</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmz61e9.html">用非递归、不用栈的方法，实现原位（in-place）的快速排序</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/o8kygp59.html">ES6 你可能不知道的事 &ndash; 基础篇</a>
			</li>
						<li><a href="https://www.batexi.com/a/4954kezq.html">WebLogic10安装图文教程</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8engdx8.html">hdu 1575     矩阵快速幂模板</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4r0w38.html">java时间库Joda-Time</a>
			</li>
						<li><a href="https://www.batexi.com/a/4954oemq.html">this的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q76rre8.html">Android  APK反编译问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8ky73j9.html">HDU 2242 考研路茫茫----空调教室</a>
			</li>
						<li><a href="https://www.batexi.com/a/g8enz7e8.html">UVA1629Cake slicing&lpar;记忆化搜索&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8m31169.html">MS-sqlserver数据库2008如何转换成2000</a>
			</li>
						<li><a href="https://www.batexi.com/a/495442mq.html">cannot get gid for group &OpenCurlyQuote;nobody&rsquo;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
